//
//  XiaYunDanViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import WebKit

class XiaYunDanViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,JiTuoWuXinXiViewDelegate,JiPaiFangShiViewControllerDelegate,ZengZhiServicesViewControllerDelegate,AdressSelectCellDelegate,DZGLViewControllerDelegate,XinZengDiZhiViewControllerDelegate{
    
    var sender:String?
    var sendPhone:String?
    var sendAdr:String?
    
    var receiver:String?
    var receivePhone:String?
    var receiveAdr:String?
    func XinZengDiZhiViewControllerFinishAction(name: String, phone: String, adr: String) {
        
        if isSend {
            sender = name
            sendPhone = phone
            sendAdr = adr
        }else{
            receiver = name
            receivePhone = phone
            receiveAdr = adr
        }
        
        listView.reloadData()
    }
    
    
    
    func DZGLViewControllerSelect(data: GetAddrsInfoDataModel) {
        
    }
    
    func AdressSelectCellBtnCLick(row: Int) {
        let vc = DZGLViewController()
        vc.cus_id = 365
        vc.isSelectMotion = true
        vc.delegate = self
        self.navigationController?.pushViewController(vc, animated: true )
    }
    var isSend = true
    func AdressSelectCellTap(row: Int) {
        let vc = XinZengDiZhiViewController()
        vc.navTitle = "新增地址"
        vc.delegate = self
        isSend = true
        if row == 1 {
            isSend = false
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    var price:Float?
    var commend = ""
    func ZengZhiServicesViewControllerFinish(price: Float, content: String) {
        self.price = price
        commend = content
        listView.reloadData()
    }
    
    
    var send = 0
    var receive = 0
    func JiPaiFangShiViewControllerDelegateFinish(send: Int, receive: Int, time: Double) {
        self.send = send
        self.receive = receive
        listView.reloadData()
    }
    
    
    
    var itemName = ""
    var tiJi:Float?
    var weight:Float?
    var count:Int?
    var isCheck:Bool?
    
    func JiTuoWuXinXiViewSubmit(itemName: String, tiJi: Float, weight: Float, count: Int, isCheck: Bool) {
        self.itemName = itemName
        self.tiJi = tiJi
        self.weight = weight
        self.count = count
        self.isCheck = isCheck
        jtwxxView?.removeFromSuperview()
        jtwxxView = nil
        listView.reloadData()
    }
    
    
    
    func JiTuoWuXinXiViewClose() {
        jtwxxView?.removeFromSuperview()
        jtwxxView = nil
    }
    var jtwxxView:JiTuoWuXinXiView?
    var selectBtn:UIButton?
    let titleArr = ["物品寄托","寄派方式","增值服务","温控范围"]
    let title2Arr = ["关联订单号","关联平台"]
    @IBOutlet weak var priceLbl: UILabel!
    @IBAction func orderAction(_ sender: Any) {
        
    }
    @IBOutlet weak var bottomView: UIView!
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "运单列表"
        self.view.addSubview(navbar)
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(bottomView.snp_top)
        }
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "AdressSelectCell", bundle: nil), forCellReuseIdentifier: "AdressSelect")
        listView.register(UINib(nibName: "PersonCenterCell", bundle: nil), forCellReuseIdentifier: "PersonCenter")
        listView.register(UINib(nibName: "TitleAndTFBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFBtnCell")
        listView.register(UINib(nibName: "WenDuCell", bundle: nil), forCellReuseIdentifier: "WenDu")
        // Do any additional setup after loading the view.
    }
    
   
    @objc func selectBtnClick(sender:UIButton){
        if sender.tag == 99 {
            //跳转查看合同页面
            let vc = WebViewController()
            vc.urlStr = "https://www.baidu.com"
            self.navigationController?.pushViewController(vc, animated: true)
            return
        }
        selectBtn!.isSelected = !selectBtn!.isSelected
    }
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 2 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 41.5*glscale))
            view.backgroundColor = UIColor(named: "app底色")
            
            let btn = UIButton()
            view.addSubview(btn)
            btn.setImage(UIImage(named: "daixuan"), for: .normal)
            btn.setImage(UIImage(named: "yuxuan"), for: .selected)
            btn.snp.makeConstraints { (make) in
                make.centerY.equalTo(view.snp_centerY)
                make.left.equalTo(15)
                make.width.height.equalTo(12.5)
            }
            selectBtn = btn
            let btn2 = UIButton()
            view.addSubview(btn2)
            btn2.addTarget(self, action: #selector(selectBtnClick(sender:)), for: .touchUpInside)
            btn2.snp.makeConstraints { (make) in
                make.top.left.bottom.equalTo(0)
                make.width.equalTo(105)
            }
            
            let lbl1 = UILabel()
            lbl1.text = "我已阅读并同意"
            lbl1.textColor = UIColor(named: "标题字颜色")
            lbl1.font = UIFont.systemFont(ofSize: 11)
            lbl1.sizeToFit()
            view.addSubview(lbl1)
            lbl1.snp.makeConstraints { (make) in
                make.left.equalTo(btn.snp_right).offset(3)
                make.top.bottom.equalTo(0)
                make.width.equalTo(lbl1.bounds.size.width)
            }
            
            let btn3 = UIButton()
            btn3.setTitle("《快件服务协议》", for: .normal)
            btn3.titleLabel?.font = UIFont.systemFont(ofSize: 11)
            btn3.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            btn3.tag = 99
            view.addSubview(btn3)
            btn3.sizeToFit()
            btn3.addTarget(self, action: #selector(selectBtnClick(sender:)), for: .touchUpInside)
            btn3.snp.makeConstraints { (make) in
                make.left.equalTo(lbl1.snp_right)
                make.top.bottom.equalTo(0)
                make.width.equalTo(btn3.bounds.size.width)
            }
            
            return view
        }
        let view = UIView()
        view.backgroundColor = UIColor(named: "app底色")
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 {
            return 10*glscale
        }
        if section == 1 {
            return 5*glscale
        }
        return 41.5*glscale
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0:return 2
        case 1:return 4
        default: return 2
        }
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        if indexPath.section == 1 {
            if indexPath.row < 3 {
                print(indexPath.row)
                switch indexPath.row {
                case 0:
                    if jtwxxView == nil {
                        let view = JiTuoWuXinXiView(frame: self.view.bounds)
                        view.delegate = self
                        self.view.addSubview(view)
                        jtwxxView = view
                    }
                    break
                case 1:
                    let vc = JiPaiFangShiViewController()
                    vc.delegate = self
                    self.navigationController?.pushViewController(vc, animated: true)
                    break
                default:
                    let vc = ZengZhiServicesViewController()
                    vc.delegate = self
                    self.navigationController?.pushViewController(vc, animated: true)
                    break
                }
            }
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            if indexPath.row == 0 {
                if sender != nil {
                    return 93
                }
            }
            if indexPath.row == 1 {
                if receiver != nil {
                    return 93
                }
            }
            return 70
        }
        if indexPath.section == 1{
            if indexPath.row == 3 {
                return 96
            }
            return 49
        }
        return 49
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            let cell = tableView.dequeueReusableCell(withIdentifier: "AdressSelect") as! AdressSelectCell
            cell.titleLbl.text = "寄"
            
            cell.tag = indexPath.row
            cell.delegate = self
            cell.contentLbl.isHidden = false
            cell.contentV.isHidden = true
            if indexPath.row == 0 {
                if sender != nil {
                    cell.contentLbl.isHidden = true
                    cell.contentV.isHidden = false
                    cell.nameLbl.text = sender!
                    cell.phoneLbl.text = sendPhone!
                    cell.adrLbl.text = sendAdr!
                }
            }
            if indexPath.row == 1 {
                cell.titleLbl.backgroundColor = UIColor(named: "企业、预售字体")
                cell.titleLbl.text = "收"
                if receiver != nil {
                    cell.contentLbl.isHidden = true
                    cell.contentV.isHidden = false
                    cell.nameLbl.text = receiver!
                    cell.phoneLbl.text = receivePhone!
                    cell.adrLbl.text = receiveAdr!
                }
            }
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "PersonCenter") as! PersonCenterCell
            cell.titleLbl.text = titleArr[indexPath.row]
            if indexPath.row == 0 {
                cell.introLbl.text = "（必填）"
                cell.introLbl.textColor = UIColor(named: "蓝色字体颜色")
                cell.introLbl.isHidden = false
                if isCheck != nil {
                    cell.contentStr = itemName + "; \(count!)箱; \(weight!)kg"
                }
            }
            if indexPath.row == 1 {
                if send != nil {
                    var sendStr = "上门提货"
                    if send != 0 {
                        sendStr = "自送到库"
                    }
                    var receiveStr = "送货上门"
                    if receive != 0 {
                        receiveStr = "到库自取"
                    }
                    cell.contentStr = sendStr + "; " + receiveStr
                }
            }
            if indexPath.row == 2 {
                cell.introLbl.isHidden = false
                if price != nil {
                    cell.contentStr = "报价金额:\(price!)"
                }
            }
            if indexPath.row == 3 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "WenDu") as! WenDuCell
                cell.titleLbl.text = titleArr[indexPath.row]
                return cell
            }
            
            
            return cell
        default:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFBtnCell") as! TitleAndTFBtnCell
            cell.nameLbl.text = title2Arr[indexPath.row]
            return cell
        }
    }
    
}
